// Generador de combinaciones sin repeticin
// (C) 2023 Salvador Pozo
// Con Clase https://conclase.net

#include <stack>

template<class T> class Combinacion {
private:
    class par {
    private:
        int nElementos, indice;
    public:
        par(int n=0,int i=0) : nElementos(n), indice(i) {}
        int NElementos() { return nElementos; }
        int Indice() { return indice; }
    };
    T *valor;
    T *comb;
    int nElementos;
    int grupo;
    par pareja;
    std::stack<par> pila;

public:
    Combinacion(T *v, int n) : nElementos(n), grupo(0), pila() {
        valor = new T[nElementos];
        for(int i=0; i<nElementos; i++) valor[i] = v[i];
    }
    ~Combinacion() {
        delete[] valor;
        delete[] comb;
    }
    bool PrimeraCombinacion(int tam) {
        if(grupo) delete[] comb;
        grupo = tam;
        comb = new T[grupo];
        return SiguienteElemento(tam,0);
    }
    bool SiguienteElemento(int ne, int i) {
        if(ne > 0) {
            pila.push(par(ne, i));
            comb[grupo-ne] = valor[i];
            SiguienteElemento(ne-1, i+1);
        }
        return true;
    }
    bool SiguienteCombinacion() {
        if(pila.empty()) return false;
        pareja = pila.top();
        pila.pop();
        if(pareja.Indice() < nElementos-pareja.NElementos()) {
            return SiguienteElemento(pareja.NElementos(), pareja.Indice()+1);
        } else {
            return SiguienteCombinacion();
        }
    }
    const T *Comb() const { return comb; }
};
