// Sudokus con Clase
// Resolucin de sudokus con tcnicas reales
// (C) 2023 Salvador Pozo
// Con Clase https://conclase.net
//
// Declaracin de la clase Grupo
//
// Se usa para detectar parejas, trios, cuartetos... ocultos

#ifndef SUDOKU_GRUPO
#define SUDOKU_GRUPO

#include "casilla.h"
#include "marcaslapiz.h"
#include "combinaciones.h"

class Grupo {
    private:
//    Casilla *grupo[9];
    int valor[9];
    Combinacion<Casilla *> comb;

    public:
    Grupo(Casilla *c[9]) : comb(c, 9) {}
    bool PrimeraCombinacion(int nElementos) { return comb.PrimeraCombinacion(nElementos); }
    bool SiguienteCombinacion() { return comb.SiguienteCombinacion(); }
    Casilla *Comb(int index) const { return comb.Comb()[index]; }
    bool Contiene(Casilla *cas, int nElementos);
    char *Casillas(int);
    char *Valores(MarcasLapiz marcas, int);
};

#endif // SUDOKU_GRUPO
